// Generated by purs version 0.11.3
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Apply = require("../Control.Apply");
var Control_Bind = require("../Control.Bind");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Decimal = require("../Data.Decimal");
var Data_Either = require("../Data.Either");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_Quantity = require("../Data.Quantity");
var Data_Semiring = require("../Data.Semiring");
var Data_Units = require("../Data.Units");
var Prelude = require("../Prelude");
var tau = Data_Quantity["scalar'"](Data_Semiring.mul(Data_Decimal.semiringDecimal)(Data_Decimal.fromNumber(2.0))(Data_Decimal.pi));
var pi = Data_Quantity["scalar'"](Data_Decimal.pi);
var modulo = function (q1) {
    return function (q2) {
        var u = Data_Quantity.derivedUnit(q1);
        return Control_Bind.bind(Data_Either.bindEither)(Data_Quantity["asValueIn'"](q1)(u))(function (v) {
            return Control_Bind.bind(Data_Either.bindEither)(Data_Quantity["asValueIn'"](q2)(u))(function (v2) {
                var res = Data_Decimal.modulo(v)(v2);
                return Control_Applicative.pure(Data_Either.applicativeEither)(Data_Quantity["quantity'"](res)(u));
            });
        });
    };
};
var lift2 = function (fn) {
    return function (q1) {
        return function (q2) {
            return Data_Functor.map(Data_Either.functorEither)(Data_Quantity["scalar'"])(Control_Apply.apply(Data_Either.applyEither)(Data_Functor.map(Data_Either.functorEither)(fn)(Data_Quantity["asValueIn'"](q1)(Data_Units.unity)))(Data_Quantity["asValueIn'"](q2)(Data_Units.unity)));
        };
    };
};
var max = lift2(Data_Decimal.max);
var min = lift2(Data_Decimal.min);
var lift = function (fn) {
    return function (q) {
        return Data_Functor.map(Data_Either.functorEither)(function ($4) {
            return Data_Quantity["scalar'"](fn($4));
        })(Data_Quantity["asValueIn'"](q)(Data_Units.unity));
    };
};
var ln = lift(Data_Decimal.ln);
var log10 = lift(Data_Decimal.log10);
var round = lift(Data_Decimal.round);
var sin = lift(Data_Decimal.sin);
var sinh = lift(Data_Decimal.sinh);
var tan = lift(Data_Decimal.tan);
var tanh = lift(Data_Decimal.tanh);
var gamma = lift(Data_Decimal.gamma);
var floor = lift(Data_Decimal.floor);
var factorial = lift(Data_Decimal.factorial);
var exp = lift(Data_Decimal.exp);
var e = Data_Quantity["scalar'"](Data_Decimal.e);
var cosh = lift(Data_Decimal.cosh);
var cos = lift(Data_Decimal.cos);
var ceil = lift(Data_Decimal.ceil);
var atanh = lift(Data_Decimal.atanh);
var atan2 = lift2(Data_Decimal.atan2);
var atan = lift(Data_Decimal.atan);
var asinh = lift(Data_Decimal.asinh);
var asin = lift(Data_Decimal.asin);
var acosh = lift(Data_Decimal.acosh);
var acos = lift(Data_Decimal.acos);
module.exports = {
    acos: acos, 
    acosh: acosh, 
    asin: asin, 
    asinh: asinh, 
    atan: atan, 
    atan2: atan2, 
    atanh: atanh, 
    ceil: ceil, 
    cos: cos, 
    cosh: cosh, 
    e: e, 
    exp: exp, 
    factorial: factorial, 
    floor: floor, 
    gamma: gamma, 
    ln: ln, 
    log10: log10, 
    max: max, 
    min: min, 
    modulo: modulo, 
    pi: pi, 
    round: round, 
    sin: sin, 
    sinh: sinh, 
    tan: tan, 
    tanh: tanh, 
    tau: tau
};
